<template>
    <div>
        <div class="row">
            <div class="col-12 border-radius-20 all-chat q-pa-md scroll">
                <div class="row">
                    <div class="col-md-7 col-12 row items-center">
                        <!-- FILTER AGENT -->
                        <select-filter
                            class="col-6 col-md-3 q-pr-md"
                            :model-value="state.selectedAgent"
                            :header="`Agent`"
                            ref="resetValue"
                            :reset="state.reset"
                            @update-confirm="updateConfirm"
                        />

                        <!-- FILTER CLIENT -->
                        <select-filter
                            class="col-6 col-md-3 q-pr-md"
                            :model-value="state.selectedClient"
                            :header="`Client`"
                            :reset="state.reset"
                            @update-confirm="updateConfirm"
                        />

                        <!-- FILTER ISSUE TYPE -->
                        <select-filter
                            class="col-6 col-md-3 q-pr-md"
                            :model-value="state.selectedIssueType"
                            :header="`Issue Type`"
                            :reset="state.reset"
                            @update-confirm="updateConfirm"
                        />
                        <!-- FILTER STATUS -->
                        <select-filter
                            class="col-6 col-md-3 q-pr-md"
                            :model-value="state.selectedStatus"
                            :header="`Status`"
                            :reset="state.reset"
                            @update-confirm="updateConfirm"
                        />
                    </div>
                    <div
                        class="
                            col-12 col-md-5
                            q-pr-md
                            row
                            items-center
                            justify-end
                        "
                    >
                        <q-btn
                            class="
                                border-radius-10
                                font-14
                                reset-btn
                                card-item-btn
                                q-mr-md
                            "
                            size="md"
                            no-caps
                            style="width: 100px; height: 40px"
                            @click="reset()"
                        >
                            Reset
                        </q-btn>
                        <q-btn
                            class="
                                border-radius-10
                                font-14
                                search-btn
                                card-item-btn
                            "
                            size="md"
                            no-caps
                            @click="searchResult()"
                            style="width: 130px; height: 40px"
                        >
                            <q-icon name="search" />
                            Search
                        </q-btn>
                    </div>
                </div>
                <vue-data-table
                    class="q-mx-lg-md q-mx-md-md q-mx-xs-none"
                    :headers="clientHeaders"
                    :data="formatData(allChat)"
                    :actions="clientActions"
                    :left-align="clientLeftAlign"
                    @update-tab="updateTab"
                    @ticket-id-state="ticketIdState"
                    :requestConversationButtonPressed="
                        requestConversationButton
                    "
                    :transferConversationButtonPressed="
                        transferConversationButton
                    "
                    :ticketIDLinkPressed="ticketIDLinkPressed"
                    :conditionChatClient="true"
                />
                <vue-data-pagination
                    v-if="pagination.total > 20"
                    :data="pagination"
                    :selectPagePressed="selectPagePressed"
                ></vue-data-pagination>
            </div>
        </div>
    </div>
</template>
<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-explicit-any*/
/* eslint-disable @typescript-eslint/no-floating-promises */
/* eslint-disable @typescript-eslint/no-misused-promises */
/* eslint-disable @typescript-eslint/require-await */
/* eslint-disable @typescript-eslint/restrict-template-expressions */
/* eslint-disable @typescript-eslint/no-implicit-any-catch */

import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    reactive,
    watch,
    onMounted,
    computed
} from 'vue';
import { mapGetters } from 'vuex';
import { date } from 'quasar';
import SelectFilter from '../chats/SelectFilter.vue';
import { ConversationListResponseResult } from '../../services/responses/conversation/ConversationListResponse';
import { useI18n } from 'vue-i18n';
import VueDataTable from 'src/components/datatable/VueDataTable.vue';
import VueDataPagination from 'src/components/datatable/VueDataPagination.vue';
import localForage from 'localforage';
import { FilterType } from 'src/services/enums/FilterType';

export default defineComponent({
    name: 'AllChat',
    components: {
        SelectFilter,
        VueDataTable,
        VueDataPagination
    },
    props: {
        requestConversationButton: {
            type: Function,
            default: () => ''
        },
        transferConversationButton: {
            type: Function,
            default: () => ''
        },
        ticketIDLink: {
            type: Function,
            default: () => ''
        }
    },
    computed: {
        ...mapGetters({
            issueTypes: 'issueType/getIssueTypesList',
            user: 'user/getUser'
        })
    },
    setup(props, { emit }) {
        const currentTime = date.formatDate(Date.now(), 'HH:mm:ss');
        let show = 1;
        const store = useStore();
        const { t } = useI18n();
        const lang = store.state.user.user?.locale;
        const filterStore = localForage.createInstance({
            name: 'lobbi/filter'
        });

        const resetValue = ref<any>();

        // computed
        const socketStatus = computed(() => {
            return store.state.conversation.socket;
        });

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const assignSuccess = computed(() => {
            return store.state.conversation.assignSuccess;
        });

        const changeStatusConvo = computed(() => {
            return store.state.conversation.changeStatusConvo;
        });

        const selectedTicketID = computed(() => {
            return store.state.conversation.selectedTicketID;
        });

        const allChat = computed(() => {
            return store.state.conversation.allChat;
        });

        const pagination = computed(() => {
            return store.state.conversation.allChatPagination;
        });

        const selectedBranch = computed(() => {
            return store.state.branch.branch;
        });

        const clientActions = ['transfer', 'request'];
        const clientLeftAlign = ['client'];

        const clientHeaders = [
            t('tables.dateTime', {}, { locale: lang }),
            t('tables.client', {}, { locale: lang }),
            t('tables.ticketId', {}, { locale: lang }),
            t('tables.issueType', {}, { locale: lang }),
            t('tables.lastAgent', {}, { locale: lang }),
            t('tables.status', {}, { locale: lang }),
            t('tables.actions', {}, { locale: lang })
        ];

        // data
        let search = ref('');
        let state = reactive({
            selectedUser: ref(''),
            conversation: [] as any,
            conversationList: [] as any,
            socketConvo: [] as any,
            pagination: [] as any,
            issuesType: [] as any,
            ticketIdState: '',
            currentPage: 1,
            convId: '' as string,
            text: '' as string,
            currentIndex: 0,
            lengths: 0,
            counter: 0,
            selectedAgent: {} as any,
            selectedClient: {} as any,
            selectedIssueType: {} as any,
            selectedStatus: {} as any,
            reset: ref(false),
            clientConversation: [] as any,
            confirm: ref(false)
        });

        watch(assignSuccess, async (currentValue) => {
            if (currentValue) {
                getConversation();
            }
        });

        watch(changeStatusConvo, async (currentValue) => {
            if (currentValue) {
                changeStatus(currentValue);
            }
        });
        watch(selectedTicketID, async (currentValue) => {
            if (currentValue) {
                ticketIdState(currentValue);
            }
        });
        watch([selectedBranch, selectedBusinessId], async (currentValue) => {
            if (currentValue) {
                getConversation();
            }
        });
        watch(socketStatus, (currentValue) => {
            if (currentValue) {
                let status = filterConversationSocket(currentValue);
                if (status == true) {
                    searchResult();
                    store.dispatch('conversation/setSocketSignal', false);
                }
            }
        });
        store.watch(
            (state) => state.business.businessID,
            () => {
                state.conversationList = [];
                if (selectedBusinessId.value) {
                    getConversation();
                }
            }
        );

        // methods
        const getConversation = async () => {
            if (store.state.role.permissions.conversation?.list) {
                const filterList = store.state.filter.chatFilter;

                let obj = {
                    page: state.currentPage,
                    isDownward: 0,
                    issueTypeIds: filterList.issueType
                        ? filterList.issueType.id
                        : '',
                    status: filterList.status ? filterList.status.value : '',
                    userId: filterList.client ? filterList.client.id : '',
                    agentId: filterList.agent ? filterList.agent.id : ''
                };

                state.conversation = [];
                const result: ConversationListResponseResult =
                    await store.dispatch('conversation/getConversation', obj);
                if (result?.conversations?.length > 0) {
                    let agentName = '-';
                    let agentID: any = null;

                    state.clientConversation = result;
                    emit('allChatConversation', result);

                    state.pagination = result.pagination;

                    if (state.counter > 0) {
                        state.counter = 0;
                    }

                    if (state.conversationList) {
                        state.conversationList = [];
                    }

                    result.conversations.forEach((element: any) => {
                        if (element.agent) {
                            agentName = element.agent.name;
                            agentID = element.agent.id;
                        } else {
                            (agentName = ''), (agentID = '');
                        }

                        // If got transfer change status to pending
                        if (element.transfer) {
                            element.status = 3;
                        }

                        // 0-WAITING, 1-ACTIVE, 2-CLOSED, 3-PENDING (Not inside api, custom status)
                        let conversationStatus = '';
                        switch (element.status) {
                            case 0:
                                conversationStatus = 'Waiting';
                                break;
                            case 1:
                                conversationStatus = 'Active';
                                break;
                            case 2:
                                conversationStatus = 'Closed';
                                break;
                            case 3:
                                conversationStatus = 'Pending';
                                break;
                        }

                        if (state.selectedStatus.value) {
                            if (state.selectedStatus.value == element.status) {
                                state.counter = state.counter + 1;
                            }
                        } else {
                            state.counter = state.counter + 1;
                        }

                        let time = date.formatDate(
                            element.createdAt,
                            'YYYY-MM-DD hh:mm A'
                        );
                        let resultsList = {
                            id: element.id,
                            date: time,
                            client: {
                                id: element.user.id,
                                name: element.user.name,
                                type: 'link'
                            },
                            ticketId: element.referenceNo,
                            issueType: element.issueType.name,
                            lastAgent: { name: agentName, id: agentID },
                            status: conversationStatus
                        };
                        state.conversationList.push(resultsList);
                    });
                    store.dispatch(
                        'conversation/setAllChatList',
                        state.conversationList
                    );
                    store.dispatch(
                        'conversation/setAllChatPagination',
                        state.pagination
                    );
                    await store.dispatch(
                        'conversation/setConversationLength',
                        state.counter
                    );
                } else {
                    store.dispatch('conversation/setAllChatList', []);
                    store.dispatch('conversation/setAllChatPagination', []);
                }

                // set assign success state
                store.dispatch('conversation/setAssignSuccess', false);
            }
        };

        const updateTab = (value: any) => {
            emit('update-tab', value);
        };

        const ticketIdState = (value: any) => {
            store.dispatch('conversation/setAllChatPending', value);
        };

        const selectPagePressed = (page: number) => {
            state.currentPage = page;
            getConversation();
        };

        const updateConfirm = async (filterList: any) => {
            filterList.page = FilterType.CHAT;
            await store.dispatch('filter/setFilterList', filterList);
        };

        const updateConvID = (value: string) => {
            state.convId = value;
        };

        const getAgent = () => {
            return state.conversation.id;
        };

        const reset = () => {
            state.selectedAgent = {};
            state.selectedClient = {};
            state.selectedIssueType = {};
            state.selectedStatus = {};
            state.reset = true;
            setTimeout(() => {
                state.reset = false;
            }, 3000);
            filterStore.clear();
            store.dispatch('filter/clearFilterList');
            state.conversationList = [];
            getConversation();
        };
        const searchResult = () => {
            state.currentPage = 1;
            state.conversationList = [];
            getConversation();
        };

        const requestConversationButtonPressed = (ticketId: string) => {
            props.requestConversationButton(ticketId);
        };

        const transferConversationButtonPressed = (ticketId: string) => {
            props.transferConversationButton(ticketId);
        };

        const ticketIDLinkPressed = (ticketId: any) => {
            props.ticketIDLink(ticketId);
        };

        const changeStatus = (status: any) => {
            store.dispatch('conversation/setAllChatStatus', status);
        };

        const formatData = (data: any) => {
            let resultsList: any = [];
            if (data) {
                data.forEach((element: any) => {
                    resultsList.push({
                        date: element.date,
                        client: {
                            id: element.client.id,
                            name: element.client.name,
                            conversation: element
                        },
                        ticketId: element.ticketId,
                        issueType: element.issueType,
                        lastAgent: element.lastAgent,
                        status: element.status
                    });
                });
                return resultsList;
            }
        };

        const filterConversationSocket = (value: any) => {
            if (
                (value.status == state.selectedStatus.value ||
                    Object.keys(state.selectedStatus).length === 0) &&
                (value.agent == null ||
                    value.agent.id == state.selectedAgent.id ||
                    Object.keys(state.selectedAgent).length === 0) &&
                (Object.keys(state.selectedClient).length === 0 ||
                    value.user.id == state.selectedClient.id) &&
                (Object.keys(state.selectedIssueType).length === 0 ||
                    value.issueType.id == state.selectedIssueType.id)
            ) {
                return true;
            } else {
                return false;
            }
        };

        onMounted(getConversation);

        return {
            tab: ref('chatting'),
            state,
            dense: ref(true),
            search,
            formatData,
            currentTime,
            getConversation,
            getAgent,
            show,
            socketStatus,
            updateConfirm,
            updateTab,
            reset,
            clientHeaders,
            clientActions,
            clientLeftAlign,
            updateConvID,
            selectPagePressed,
            resetValue,
            transferConversationButtonPressed,
            requestConversationButtonPressed,
            searchResult,
            filterConversationSocket,
            ticketIDLinkPressed,
            changeStatusConvo,
            changeStatus,
            ticketIdState,
            allChat,
            pagination
        };
    }
});
</script>
